#include <algorithm>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <vector>

using namespace std;

const int tests_start = 10;
ofstream out;
int current_test;

const int n = 4;
double t[4][4];

void new_test()
{
    if (current_test >= tests_start) out.close();
    current_test++;
    ostringstream ss;
    ss << setfill('0') << setw(2) << current_test;
    out.open(ss.str().c_str());
    cout << ss.str() << endl;
}

void gen_random_test(int n, int k, int m)
{
    new_test();
    out << n << " " << k << endl;
    for (int i = 0; i < n; i++) {
        int x = rand() % (2*m+1) - m;
        int y = rand() % (2*m+1) - m;
        int r = rand() % m + 1;
        out << x << " " << y << " " << r << endl;
    }
    for (int i = 0; i < k; i++) {
        int x = rand() % (2*m+1) - m;
        int y = rand() % (2*m+1) - m;
        out << x << " " << y << endl;
    }
}

void gen_sophisticated_test()
{
    new_test();
    int n = 1000, k = 1000;
    int m = 1000;
    out << n << " " << k << endl;
    for (int i = 0; i < n; i++) {
        int x = rand() % (2*m+1) - m;
        int y = rand() % (2*m+1) - m;
        out << x << " " << y << " " << 500 << endl;
    }
    for (int i = 0; i < k; i++) {
        int x = i%2 ? 1000 : -1000;
        int y = -m + (i/2)*4;
        out << x << " " << y << endl;
    }
}

int main()
{
    current_test = tests_start-1;
    srand(20120506);

    gen_random_test(10, 10, 10);
    gen_random_test(100, 100, 100);
    gen_random_test(1, 1000, 1000);
    gen_random_test(1000, 2, 1000);
    gen_random_test(1000, 1000, 1000);
    gen_sophisticated_test();
}
