#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>

using namespace std;

#define SQR(x) ((x)*(x))

const int maxn = 1010;
const double eps = 1e-12;

int x[maxn], y[maxn], r[maxn];
double ans[maxn];
int xx[maxn], yy[maxn];
vector<pair<double, int> > ev[maxn];
int n, k;

double dist(int i, double t1, double t2)
{
    double x1 = xx[i] + (xx[i+1]-xx[i])*t1;
    double y1 = yy[i] + (yy[i+1]-yy[i])*t1;

    double x2 = xx[i] + (xx[i+1]-xx[i])*t2;
    double y2 = yy[i] + (yy[i+1]-yy[i])*t2;

    return sqrt(SQR(x2-x1) + SQR(y2-y1));
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i, j;

    scanf("%d%d", &n, &k);
    for (i = 0; i < n; i++) {
        scanf("%d%d%d", &x[i+1], &y[i+1], &r[i+1]);
    }
    for (i = 0; i < k; i++) {
        scanf("%d%d", &xx[i], &yy[i]);
        if (i < k-1) {
            ev[i].push_back(make_pair(0.0, 0));
            ev[i].push_back(make_pair(1.0, 0));
        }
    }

    for (i = 0; i < k-1; i++) {
        for (j = 1; j <= n; j++) {
            int x1 = xx[i] - x[j];
            int y1 = yy[i] - y[j];
            int dx = xx[i+1] - xx[i];
            int dy = yy[i+1] - yy[i];
            double A = dx*dx + dy*dy;
            double B = 2*(x1*dx + y1*dy);
            double C = x1*x1 + y1*y1 - r[j]*r[j];
            double D = B*B - 4*A*C;

            if (D <= 0.0) continue;

            double t;
            t = (-B - sqrt(D)) / (2*A);
            if (t > -eps && t < 1+eps) {
                if (t < 0) t = 0;
                if (t > 1) t = 1;
                ev[i].push_back(make_pair(t, j));
            }
            t = (-B + sqrt(D)) / (2*A);
            if (t > -eps && t < 1+eps) {
                if (t < 0) t = 0;
                if (t > 1) t = 1;
                ev[i].push_back(make_pair(t, -j));
            }
        }
    }

    set<int> active;
    for (i = 1; i <= n; i++) {
        if (SQR(xx[0]-x[i]) + SQR(yy[0]-y[i]) <= r[i]*r[i])
            active.insert(i);
    }
    for (i = 0; i < k-1; i++) {
        sort(ev[i].begin(), ev[i].end());
        for (j = 0; j < ev[i].size()-1; j++) {
            if (ev[i][j].second < 0) {
                active.erase(-ev[i][j].second);
            } else if (ev[i][j].second > 0) {
                active.insert(ev[i][j].second);
            }
            ans[active.size()] += dist(i, ev[i][j].first, ev[i][j+1].first);
        }
    }

    cout << fixed << setprecision(6);
    double sum = 0;
    for (i = 0; i <= n; i++) {
        cout << ans[i] << endl;
        sum += ans[i];
    }

    double sum1 = 0;
    for (i = 0; i < k-1; i++) {
        sum1 += sqrt(SQR(xx[i+1]-xx[i]) + SQR(yy[i+1]-yy[i]) + 0.0);
    }
    assert(fabsl(sum-sum1) < 1e-7);

    fclose(stdin); fclose(stdout);
    return 0;   
}
